'FFSubmenu=Passbuilder
'FFName=Passbuilder
'FFPath=passbuilder.vbs
'** Start Dialog Passbuilder **
FF_AddDialog "Passbuilder",105,105
FF_AddControl "Passbuilder","Belichter:","STATIC",3,12,33,11
FF_AddControl "Passbuilder","Format:","STATIC",3,25,33,11
FF_AddControl "Passbuilder","DPI","STATIC",3,39,33,11
FF_AddControl "Passbuilder","Breite cm","STATIC",3,52,33,11
FF_AddControl "Passbuilder","Hhe cm","STATIC",3,64,33,11
FF_AddControl "Passbuilder","Rand mm","STATIC",3,76,33,11
FF_AddControl "Passbuilder","comBelichter","COMBO",32,12,70,10
FF_AddControl "Passbuilder","comFormat","COMBO",32,25,70,10
FF_AddControl "Passbuilder","txtDPI","EDIT",32,39,33,10
FF_SetControlStyle "Passbuilder","txtDPI",8194
FF_AddControl "Passbuilder","txtWidth","EDIT",32,52,33,10
FF_SetControlStyle "Passbuilder","txtWidth",8194
FF_AddControl "Passbuilder","txtHeight","EDIT",32,65,33,10
FF_SetControlStyle "Passbuilder","txtHeight",8194
FF_AddControl "Passbuilder","txtRand","EDIT",32,77,33,10
FF_SetControlStyle "Passbuilder","txtRand",8194
FF_AddControl "Passbuilder","Okay","BUTTON",3,91,33,11
FF_AddControl "Passbuilder","Abbruch","BUTTON",68,91,33,12
FF_AddControl "Passbuilder","Angaben zur Ausgabe:","STATIC",3,0,102,11
'** End Dialog Passbuilder **

bolOK = False
If FF_GetMajor() >= 2 AND FF_GetMinor() > 77 Then
	bolOK = True
End If
If FF_GetMajor() >= 2 AND FF_GetMinor() = 77 AND FF_GetBuild() >= 13 Then
	bolOK = True
End If
If not bolOK Then	
	FF_ErrorBreak("Sorry, aber es wird mind. Beta 13 der 2.77er Version bentigt!")
End if

frmMain = "Passbuilder"
If FF_GetImageCount() > 1 Then
	FF_ErrorBreak("Bitte nur ein Bild auswhlen!")
End If
If FF_GetImageCount() < 1 Then
	FF_ErrorBreak("Bitte ein Bild auswhlen!")
End If

a = split(FF_PSGetList(), Chr(13) & Chr(10))
For x = 0 to UBound(a)
	FF_SetControl "Passbuilder", "comBelichter", a(x)
Next
Call comFormat_load()

StrImage = FF_GetImageName(0)

Call Einstellungen_Laden()
Do 
	res = FF_ShowDialog(frmMain)
	Select Case  res 
		Case "comBelichter"
			' comFormat fllen
			Call comFormat_load()
		Case "comFormat"
			Call comFormat_Change()
		Case "Okay"		
			Call CreatePass()
			Call Einstellungen_Speichern()
			Exit Do
		Case "Abbruch"
			Exit Do
		Case "CANCEL"
			Exit Do 
	End Select 	
Loop 

FF_CloseDialog frmMain

' Progrmm Ende
Private Sub comFormat_load()
	' comFormat mit Daten fllen
	'  lschen:
	FF_SetControl "Passbuilder", "comFormat", ""
	m = FF_PSGetFormatCount(FF_GetControl("Passbuilder", "comBelichter"))			
	strBelichter = FF_GetControl("Passbuilder", "comBelichter")
	For x = 1 to m -1
		FF_SetControl "Passbuilder", "comFormat", FF_PSGetFormatName(strBelichter, x)
	Next				
End Sub

Private Sub comFormat_Change()
	strBelichter = FF_GetControl("Passbuilder", "comBelichter")	
	m = FF_PSGetFormatCount(FF_GetControl("Passbuilder", "comBelichter"))			
	For x = 1 to m -1
		If FF_PSGetFormatName(strBelichter, x) = FF_GetControl("Passbuilder", "comFormat") Then
			intFormat = x
			Exit For
		End if
	Next					
	If not FF_GetControl("Passbuilder", "comFormat") ="" Then
		FF_SetControl "Passbuilder", "txtDPI", FF_PSGetFormatDPI(strBelichter, intFormat)
		FF_SetControl "Passbuilder", "txtHeight", FF_PSGetFormatHeight(strBelichter, intFormat)
		FF_SetControl "Passbuilder", "txtWidth", FF_PSGetFormatWidth(strBelichter, intFormat)
	End if
End Sub

Private Function Einstellungen_Laden()
	f = FF_GetProfile("Passbuilder", "comBelichter")
	If not f = "" Then FF_SetControl frmMain, "comBelichter", f
	f = FF_GetProfile("Passbuilder", "comFormat")
	If not f = "" Then FF_SetControl frmMain, "comFormat", f
	FF_SetControl frmMain, "txtDPI", FF_GetProfile("Passbuilder", "txtDPI")
	FF_SetControl frmMain, "txtWidth", FF_GetProfile("Passbuilder", "txtWidth")
	FF_SetControl frmMain, "txtHeight", FF_GetProfile("Passbuilder", "txtHeight")
	FF_SetControl frmMain, "txtRand", FF_GetProfile("Passbuilder", "txtRand")
End Function

Private Function Einstellungen_Speichern()
	Call FF_WriteProfile("Passbuilder", "comBelichter", FF_GetControl(frmMain, "comBelichter"))
	Call FF_WriteProfile("Passbuilder", "comFormat", FF_GetControl(frmMain, "comFormat"))
	Call FF_WriteProfile("Passbuilder", "txtDPI", FF_GetControl(frmMain, "txtDPI"))
	Call FF_WriteProfile("Passbuilder", "txtWidth", FF_GetControl(frmMain, "txtWidth"))
	Call FF_WriteProfile("Passbuilder", "txtHeight", FF_GetControl(frmMain, "txtHeight"))
	Call FF_WriteProfile("Passbuilder", "txtRand", FF_GetControl(frmMain, "txtRand"))
End Function

Private Function CreatePass()
	breite_cm = FF_GetControl(frmMain, "txtWidth")
	hoehe_cm  = FF_GetControl(frmMain, "txtHeight")
	rand_mm	  = FF_GetControl(frmMain, "txtRand")
	dpi = FF_GetControl(frmMain, "txtDPI")
	
	breite = CInt(breite_cm * 0.39 * dpi)
	hoehe = CInt(hoehe_cm * 0.39 * dpi)
	
	rand = CInt(rand_mm * 0.039 * dpi)
	
	pass_breite = CInt(3.5 * 0.39 * dpi)
	pass_hoehe = CInt(4.5 * 0.39 * dpi)
	
	Call FF_NewImage(breite, hoehe,16777215)
	Call FF_PushImage()
	
	' Bild laden
	Call FF_LoadImage(strImage)
	If FF_GetImageWidth() > FF_GetImageHeight() Then
		Call FF_Rotate(-90, FALSE)
	End If
	Call FF_Scale(pass_breite,pass_hoehe,False)
	
	' Bilder einfgen
	x = rand 
	y = rand
	
	Do While(x + pass_breite < breite)
		Do While(y + pass_hoehe < hoehe)
			Call FF_MixImage(x, y, pass_breite, pass_hoehe, 255)
			y = y + pass_hoehe + rand
		Loop
		y = rand
		x = x + rand + pass_breite
	Loop
		
	Call FF_PopImage()
	Call FF_Reload()	
	' DPI festlegen
	Call FF_SetDPI(dpi)	
End Function

